summaryrefslogtreecommitdiff
path: root/tests/misc
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2011-12-27 00:30:23 +0000
committerPádraig Brady <P@draigBrady.com>2012-01-03 11:36:32 +0000
commit77ea441f79aa115f79b47d9c1fc9c0004c5c7111 (patch)
tree8228c30cde49ff735ca71b2ef9044a1ef833fe36 /tests/misc
parent76352c770e37de94140e0df4534462ff553c798b (diff)
downloadcoreutils-77ea441f79aa115f79b47d9c1fc9c0004c5c7111.tar.xz
realpath: a new program to print the resolved path
This program is compatible with other realpath(1) implementations, and also incorporates relpath like support, through the --relative options. The relpath support was suggested by Peng Yu, who also provided an initial implemenation of that functionality. * AUTHORS: Add my name. * NEWS: Mention the new command. * README: Likewise. * doc/coreutils.texi (realpath invocation): Add realpath info. * man/Makefile.am (realpath.1): Add dependency. * man/realpath.x: New template. * man/.gitignore: Ignore generated man page. * po/POTFILES.in: Add src/realpath.c. * src/.gitignore: Exclude realpath. * src/Makefile.am (EXTRA_PROGRAMS): Add realpath. * src/realpath.c: New file. * scripts/git-hooks/commit-msg: Add realpath to the list of prefixes. * tests/Makefile.am (TESTS): Add misc/realpath. * tests/misc/realpath: New file.
Diffstat (limited to 'tests/misc')
-rwxr-xr-xtests/misc/help-version1
-rwxr-xr-xtests/misc/realpath53
2 files changed, 54 insertions, 0 deletions
diff --git a/tests/misc/help-version b/tests/misc/help-version
index d89d7e0f5..bba6d3663 100755
--- a/tests/misc/help-version
+++ b/tests/misc/help-version
@@ -177,6 +177,7 @@ ln_setup () { args="$tmp_in ln-target"; }
ginstall_setup () { args="$tmp_in $tmp_in2"; }
mv_setup () { args="$tmp_in $tmp_in2"; }
mkdir_setup () { args=$tmp_dir/subdir; }
+realpath_setup () { args=$tmp_in; }
rmdir_setup () { args=$tmp_dir; }
rm_setup () { args=$tmp_in; }
shred_setup () { args=$tmp_in; }
diff --git a/tests/misc/realpath b/tests/misc/realpath
new file mode 100755
index 000000000..4b1e1f117
--- /dev/null
+++ b/tests/misc/realpath
@@ -0,0 +1,53 @@
+#!/bin/sh
+# Validate realpath operation
+
+# Copyright (C) 2011-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ realpath
+
+# Setup dir, file, symlink structure
+
+mkdir -p dir1/dir2
+ln -s dir1/dir2 ldir2
+touch dir1/f dir1/dir2/f
+
+# Basic operaion
+realpath -Pqz . >/dev/null || fail=1
+# --relative-base and --relative-to require params
+realpath --relative-base --relative-to . && fail=1
+# --relative-base requires --relative-to
+realpath --relative-base=dir1 . && fail=1
+
+# -e --relative-* require directories
+realpath -e --relative-to=dir1/f --relative-base=. . && fail=1
+realpath -e --relative-to=dir1/ --relative-base=. . || fail=1
+
+# Note NUL params are unconditionally rejected by canonicalize_filename_mode
+realpath -m '' && fail=1
+
+# symlink resolution
+this=$(realpath .)
+test $(realpath $relative ldir2/..) = "$this/dir1" || fail=1
+test $(realpath -L $relative ldir2/..) = "$this" || fail=1
+test $(realpath -s $relative ldir2) = "$this/ldir2" || fail=1
+
+# relative string handling
+test $(realpath -m --relative-to=prefix prefixed/1) = '../prefixed/1' || fail=1
+test $(realpath -m --relative-to=prefixed prefix/1) = '../prefix/1' || fail=1
+test $(realpath -m --relative-to=prefixed prefixed/1) = '1' || fail=1
+
+Exit $fail